import sys,os,time
from ctypes import * 


partner_connected = 0
ch = c_void_p(0) # connection handle
oh = c_void_p(0) # operational handle
nh = c_void_p(0) # node handle
NULL = c_void_p(0)
local_service_id = c_ulong(0x8001)
remote_service_id = c_ulong(0x8002)

# Win32: C:\Program Files\Common Files\TI Shared\CommLib\1\NavNet 
# Win64: C:\Program Files (x86)\Common Files\TI Shared\CommLib\1\NavNet
if os.environ.get("CommonProgramFiles(x86)"):      # Win64
 pt = os.environ.get("CommonProgramFiles(x86)") 
 nndll = pt + '\TI Shared\CommLib\\1\NavNet' + "\\navnet.dll"
else:                                              # Win32
 pt = os.environ.get("CommonProgramFiles") 
 nndll = pt +'\TI Shared\CommLib\\1\NavNet' + "\\navnet.dll"

def service_cb(a, b):
     print "py_cmp_func", a, b
     return 0

def notify_cb():
     global partner_connected
     partner_connected = 1
     return 0

def screen_cb(rectangle, string, integerbox):
     print "screen_cb", string
     return 1

def statString(s):
 for key, value in nnconstants.items():
  if value == s: return key
 return "Unlisted code value %d" % (s)

############# load NavNet.dll and prototype functions
nn = cdll.LoadLibrary(nndll)    


# 
status = nn.TI_NN_Init("-c 0 -d 0")
print "TI_NN_Init:%d" %(status)

# setup the callback for TI_NN_RegisterNotifyCallback
CBFUNC = CFUNCTYPE(c_int)
#cb_func = CBFUNC(service_cb)
cb_func2 = CBFUNC(notify_cb)

status = nn.TI_NN_RegisterNotifyCallback(0, cb_func2)
while partner_connected == 0:
 time.sleep(1)
print "TI_NN_RegisterNotifyCallback %d:" % (status)

oh = nn.TI_NN_CreateOperationHandle()
print "TI_NN_CreateOperationHandle %x:" % (oh)
nn.TI_NN_NodeEnumInit(oh)
nn.TI_NN_NodeEnumNext(oh,byref(nh))
nn.TI_NN_NodeEnumDone(oh)
nn.TI_NN_DestroyOperationHandle(oh)
oh = NULL
print "remote node handle:", byref(nh)
status = nn.TI_NN_Connect(nh,0x4060,byref(ch))
print "TI_NN_Connect:", status

oh = nn.TI_NN_CreateOperationHandle()
########### setup screendump 
screenbuf = create_string_buffer('\000' * 0x25800) # CX = 0x25800 , classic = 0x9600
IntegerBox = c_ulong(0x9600)    # size of buffer
Rectangle = c_int * 6 # struct Rectangle is 6 words = 24 bytes
CXrectangle = Rectangle(0,0,320,240,16,0)
classicrectangle = Rectangle(0,0,320,240,4,0)
nn.TI_NN_GetNodeScreen(nh,oh,screenbuf,byref(IntegerBox),classicrectangle )
print "TI_NN_GetNodeScreen:", status

nn.TI_NN_DestroyOperationHandle(oh)

nn.TI_NN_Disconnect(ch)
nn.TI_NN_Shutdown()
print "size of screen capture",hex(IntegerBox.value)

# ---- prepend BMP header and save to file
BMP = "\x42\x4D\x0E\x9E\x00\x00\x00\x00\x00\x00\x76\x00\x00\x00"  
# dib header
BMP += "\x28\x00\x00\x00\x40\x01\x00\x00\xF0\x00\x00\x00\x01\x00\x04\x00\x00\x00\x00\x00\x00\x96\x00\x00\xC4\x0E\x00\x00\xC4\x0E\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
# 4bit greyscale palette
BMP += "\x00\x00\x00\x00\x11\x11\x11\x00\x22\x22\x22\x00\x33\x33\x33\x00"
BMP += "\x44\x44\x44\x00\x55\x55\x55\x00\x66\x66\x66\x00\x77\x77\x77\x00"
BMP += "\x88\x88\x88\x00\x99\x99\x99\x00\xAA\xAA\xAA\x00\xBB\xBB\xBB\x00"
BMP += "\xCC\xCC\xCC\x00\xDD\xDD\xDD\x00\xEE\xEE\xEE\x00\xFF\xFF\xFF\x00"
FILE = open("screen.bmp", "wb")
FILE.write(BMP)
for r in xrange(38400, 0,-160):
 FILE.write(screenbuf.raw[r-160:r])  # get screen upside down 
FILE.close()

"""
struct Rectangle 
    int x;
    int y;
    int width;
    int height;
    int bitsPerPixel;
    int sampleModel;
"""