import sys,os,time,msvcrt 
from ctypes import * 

partner_connected = 0
ch = c_void_p(0) # connection handle
oh = c_void_p(0) # operational handle
nh = c_void_p(0) # node handle
dh = c_void_p(0) # device handle
NULL = c_void_p(0)

VIRTUAL_KEY_SVC = c_ulong(0x4042)
VIRTUAL_KEY_STROKE_EVENT_COMMAND = c_ulong(0x80000001) # 1, 0, 0, -128 =>0x80000001 TE_MLPDev?


def notify_cb():
     global partner_connected
     print "Notify callback called"
     partner_connected = 1
     return 0

uchr = lambda x: chr((256+x) % 256)  # unsigned ints

# --- taken from NspireVirtualKeyStroke.class
def getkeycode(pckey):
    #print hex(pckey)
    if pckey == 0x1b:   return [27, -106, 0]   #ESC_KEY_BYTES
    if pckey == 0xffff: return [0, -17, 0]     #CTRL_ESC_KEY_BYTES
    if pckey == 0x09: return [9, -107, 0] #TAB_KEY_BYTES       
    if pckey == 0xffff: return [124, -107, 0]  #SHIFT_TAB_KEY_BYTES        
    if pckey == 0xffff: return [0, -19, 0]     #CTRL_TAB_KEY_BYTES       
    if pckey == 0xffff: return [0, -3, 0]      #HOME_KEY_BYTES     
    if pckey == 0xffff: return [0, -2, 0]      #CTRL_HOME_KEY_BYTES      
    if pckey == 0xffff: return [0, 54, 0]      #MENU_KEY_BYTES        
    if pckey == 0xffff: return [0, -50, 0]     #CTRL_MENU_KEY_BYTES        
    if pckey == 0xffff: return [ 0, -96, 0] #MOUSE_CONTEXT_MENU_KEY_BYTES
    if pckey == 0xffff: return [0, -83, 0] #CLICK_KEY_BYTES     
    if pckey == 0xffff: return [0, -84, 0] #CTRL_CLICK_KEY_BYTES    
    if pckey == 0xffff: return [0, -7, 0] #SHIFT_GRAB_KEY_BYTES     
    if pckey == 0x4be0: return [0, 7, 0] #LEFT_KEY_BYTES
    if pckey == 0xffff: return [0, -15, 0] #SHIFT_LEFT_KEY_BYTES
    if pckey == 0xffff: return [0, 7, 3] #SHIFT_HOLD_LEFT_KEY_BYTES
    if pckey == 0xffff: return [0, -38, 0] #CTRL_LEFT_KEY_BYTES
    if pckey == 0x4de0: return [0, 39, 0] #RIGHT_KEY_BYTES
    if pckey == 0xffff: return [0, -14, 0] #SHIFT_RIGHT_KEY_BYTES
    if pckey == 0xffff: return [0, 39, 3] #SHIFT_HOLD_RIGHT_KEY_BYTES
    if pckey == 0xffff: return [0, -37, 0] #CTRL_RIGHT_KEY_BYTES
    if pckey == 0x48e0: return [0, 23, 0] #UP_KEY_BYTES
    if pckey == 0xffff: return [0, -13, 0] #SHIFT_UP_KEY_BYTES
    if pckey == 0xffff: return [0, 23, 3   ] #SHIFT_HOLD_UP_KEY_BYTES
    if pckey == 0xffff: return [0, -36, 0] #CTRL_UP_KEY_BYTES
    if pckey == 0x50e0: return [0, 55, 0] #DOWN_KEY_BYTES
    if pckey == 0xffff: return [0, -12, 0] #SHIFT_DOWN_KEY_BYTES
    if pckey == 0xffff: return [0, 55, 3] #SHIFT_HOLD_DOWN_KEY_BYTES
    if pckey == 0xffff: return [0, -35, 0] #CTRL_DOWN_KEY_BYTES
    if pckey == ord('='): return [61, 117, 0] #EQUAL_KEY_BYTES
    if pckey == 0xffff: return [0, -23, 0] #CTRL_EQUAL_KEY_BYTES
    if pckey == 0xffff: return [124, -19, 0] #SUCH_THAT_KEY_BYTES
    if pckey == ord('a'): return [97, 102, 0] #A_KEY_BYTES
    if pckey == ord('A'): return [65, 102, 0] #SHIFT_A_KEY_BYTES
    if pckey == 0xffff: return [97, 102, 0] #CTRL_A_KEY_BYTES
    if pckey == ord('b'): return [98, 70, 0] #B_KEY_BYTES
    if pckey == ord('B'): return [66, 70, 0] #SHIFT_B_KEY_BYTES
    if pckey == 0xffff: return [2, -79, 0] #CTRL_B_KEY_BYTES
    if pckey == ord('c'): return [99, 38, 0] #C_KEY_BYTES
    if pckey == ord('C'): return [67, 38, 0] #SHIFT_C_KEY_BYTES
    if pckey == 0xffff: return [3, -78, 0] #CTRL_C_KEY_BYTES
    if pckey == 0xffff: return [0, -89, 0] #FLAG_KEY_BYTES
    if pckey == 0xffff: return [0, -8, 0] #CTRL_FLAG_KEY_BYTES
    if pckey == ord('<'): return [60, -90, 0] #LESS_THAN_KEY_BYTES
    if pckey == 0xffff: return [0, -49, 0] #CTRL_LESS_THAN_KEY_BYTES
    if pckey == ord('d'): return [100, -123, 0] #D_KEY_BYTES
    if pckey == ord('D'): return [68, -123, 0] #SHIFT_D_KEY_BYTES
    if pckey == 0xffff: return [4, -77, 0] #CTRL_D_KEY_BYTES
    if pckey == ord('e'): return [101, 101, 0] #E_KEY_BYTES
    if pckey == ord('E'): return [69, 101, 0] #SHIFT_E_KEY_BYTES
    if pckey == 0xffff: return [5, -76, 0] #CTRL_E_KEY_BYTES
    if pckey == ord('f'): return [102, 69, 0] #F_KEY_BYTES
    if pckey == ord('F'): return [70, 69, 0] #SHIFT_F_KEY_BYTES
    if pckey == 0xffff: return [6, -75, 0] #CTRL_F_KEY_BYTES
    if pckey == ord('g'): return [103, 37, 0] #G_KEY_BYTES
    if pckey == ord('G'): return [71, 37, 0] #SHIFT_G_KEY_BYTES
    if pckey == 0xffff: return [7, -74, 0] #CTRL_G_KEY_BYTES
    if pckey == ord('~'): return [39, -11, 0] #TILDE_KEY_BYTES
    if pckey == 0xffff: return [36, 5, 0] #CTRL_TILDE_KEY_BYTES
    if pckey == ord('>'): return [62, -122, 0] #GREATER_THAN_KEY_BYTES
    if pckey == 0xffff: return [0, -34, 0] #CTRL_GREATER_THAN_KEY_BYTES
    if pckey == ord('h'): return [104, -124, 0] #H_KEY_BYTES
    if pckey == ord('H'): return [72, -124, 0] #SHIFT_H_KEY_BYTES
    if pckey == 0xffff: return [8, -73, 0] #CTRL_H_KEY_BYTES
    if pckey == ord('i'): return [105, 100, 0] #I_KEY_BYTES
    if pckey == ord('I'): return [73, 100, 0] #SHIFT_I_KEY_BYTES
    if pckey == 0xffff: return [9, -72, 0] #CTRL_I_KEY_BYTES
    if pckey == ord('j'): return [106, 68, 0] #J_KEY_BYTES
    if pckey == ord('J'): return [74, 68, 0] #SHIFT_J_KEY_BYTES
    if pckey == 0xffff: return [10, -71, 0] #CTRL_J_KEY_BYTES
    if pckey == ord('k'): return [107, 36, 0] #K_KEY_BYTES
    if pckey == ord('K'): return [75, 36, 0] #SHIFT_K_KEY_BYTES
    if pckey == 0xffff: return [11, -70, 0] #CTRL_K_KEY_BYTES
    if pckey == ord('"'): return [34, -95, 0] #QUOTE_KEY_BYTES
    if pckey == 0xffff: return [0, -94, 0] #IMAGINARY_KEY_BYTES
    if pckey == 0xffff: return [0, -95, 0] #CTRL_IMAGINARY_KEY_BYTES
    if pckey == ord('l'): return [108, -125, 0] #L_KEY_BYTES
    if pckey == ord('L'): return [76, -125, 0] #SHIFT_L_KEY_BYTES
    if pckey == 0xffff: return [12, -69, 0] #CTRL_L_KEY_BYTES
    if pckey == ord('m'): return [109, 99, 0] #M_KEY_BYTES
    if pckey == ord('M'): return [77, 99, 0] #SHIFT_M_KEY_BYTES
    if pckey == 0xffff: return [13, -68, 0] #CTRL_M_KEY_BYTES
    if pckey == ord('n'): return [110, 67, 0] #N_KEY_BYTES
    if pckey == ord('N'): return [78, 67, 0] #SHIFT_N_KEY_BYTES
    if pckey == 0xffff: return [14, -67, 0] #CTRL_N_KEY_BYTES
    if pckey == ord('o'): return [111, 35, 0] #O_KEY_BYTES
    if pckey == ord('O'): return [79, 35, 0] #SHIFT_O_KEY_BYTES
    if pckey == 0xffff: return [15, -66, 0] #CTRL_O_KEY_BYTES
    if pckey == ord(':'): return [58, 1, 0] #COLON_KEY_BYTES
    if pckey == 0xffff: return [59, 2, 0] #CTRL_COLON_KEY_BYTES
    if pckey == 0xffff: return [0, -92, 0] #EXP_KEY_BYTES
    if pckey == ord('p'): return [112, -126, 0] #P_KEY_BYTES
    if pckey == ord('P'): return [80, -126, 0] #SHIFT_P_KEY_BYTES
    if pckey == 0xffff: return [16, -65, 0] #CTRL_P_KEY_BYTES
    if pckey == ord('q'): return [113, 98, 0] #Q_KEY_BYTES
    if pckey == ord('Q'): return [81, 98, 0] #SHIFT_Q_KEY_BYTES
    if pckey == 0xffff: return [17, -64, 0] #CTRL_Q_KEY_BYTES
    if pckey == ord('r'): return [114, 66, 0] #R_KEY_BYTES
    if pckey == ord('R'): return [82, 66, 0] #SHIFT_R_KEY_BYTES
    if pckey == 0xffff: return [18, -63, 0] #CTRL_R_KEY_BYTES
    if pckey == ord('s'): return [115, 34, 0] #S_KEY_BYTES
    if pckey == ord('S'): return [83, 34, 0] #SHIFT_S_KEY_BYTES
    if pckey == 0xffff: return [19, -62, 0] #CTRL_S_KEY_BYTES
    if pckey == ord('?'): return [63, 3, 0] #QUESTION_MARK_KEY_BYTES
    if pckey == 0xffff: return [0, -53, 0] #CTRL_QUESTION_MARK_KEY_BYTES
    if pckey == 0xffff: return [0, -93, 0] #PI_KEY_BYTES
    if pckey == 0xffff: return [0, -12, 0] #CTRL_PI_KEY_BYTES
    if pckey == ord('t'): return [116, -127, 0] #T_KEY_BYTES
    if pckey == ord('T'): return [84, -127, 0] #SHIFT_T_KEY_BYTES    
    if pckey == 0xffff: return [20, -61, 0] #CTRL_T_KEY_BYTES
    if pckey == ord('u'): return [117, 97, 0] #U_KEY_BYTES
    if pckey == ord('U'): return [85, 97, 0] #SHIFT_U_KEY_BYTES
    if pckey == 0xffff: return [21, -60, 0] #CTRL_U_KEY_BYTES
    if pckey == ord('v'): return [118, 65, 0] #V_KEY_BYTES
    if pckey == ord('V'): return [86, 65, 0] #SHIFT_V_KEY_BYTES
    if pckey == 0xffff: return [22, -59, 0] #CTRL_V_KEY_BYTES
    if pckey == ord('w'): return [119, 33, 0] #W_KEY_BYTES
    if pckey == ord('W'): return [87, 33, 0] #SHIFT_W_KEY_BYTES
    if pckey == 0xffff: return [23, -58, 0] #CTRL_W_KEY_BYTES
    if pckey == ord(','): return [44, -96, 0] #COMMA_KEY_BYTES
    if pckey == 0xffff: return [-120, 6, 0] #THETA_KEY_BYTES
    if pckey == ord('x'): return [120, -128, 0] #X_KEY_BYTES
    if pckey == ord('X'): return [88, -128, 0] #SHIFT_X_KEY_BYTES
    if pckey == 0xffff: return [24, -57, 0] #CTRL_X_KEY_BYTES
    if pckey == ord('y'): return [121, 96, 0] #Y_KEY_BYTES
    if pckey == ord('Y'): return [89, 96, 0] #SHIFT_Y_KEY_BYTES
    if pckey == 0xffff: return [25, -56, 0] #CTRL_Y_KEY_BYTES
    if pckey == ord('z'): return [122, 64, 0] #Z_KEY_BYTES
    if pckey == ord('Z'): return [90, 64, 0] #SHIFT_Z_KEY_BYTES
    if pckey == 0xffff: return [26, -55, 0] #CTRL_Z_KEY_BYTES
    if pckey == ord(' '): return [32, 32, 0] #SPACE_KEY_BYTES
    if pckey == 0xffff: return [0, -51, 0] #CTRL_SPACE_KEY_BYTES
    if pckey == 0x0a: return [0, 10, 0] #NEW_LINE_KEY_BYTES
    if pckey == 0xffff: return [0, -86, 4] #CTRL_KEY_BYTES
    if pckey == 0xffff: return [0, -85, 3] #SHIFT_KEY_BYTES
    if pckey == 0xffff: return [0, -85, 7] #CTRL_SHIFT_KEY_BYTES
    if pckey == 0x08: return [8, 21, 0] #BACK_SPACE_KEY_BYTES
    if pckey == 0xffff: return [8, 21, 0] #SHIFT_BACK_SPACE_KEY_BYTES
    if pckey == 0xffff: return [0, -29, 4] #CTRL_BACK_SPACE_KEY_BYTES
    if pckey == 0xffff: return [0, -81, 0] #VAR_KEY_BYTES
    if pckey == 0xffff: return [0, -88, 0] #CTRL_VAR_KEY_BYTES
    if pckey == ord('('): return [40, 85, 0] #LEFT_PARENTHESES_KEY_BYTES
    if pckey == 0xffff: return [0, -25, 0] #CTRL_LEFT_PARENTHESES_KEY_BYTES
    if pckey == ord(')'): return [41, 53, 0] #RIGHT_PARENTHESES_KEY_BYTES
    if pckey == 0xffff: return [0, -27, 0] #CTRL_RIGHT_PARENTHESES_KEY_BYTES
    if pckey == 0xffff: return [0, -111, 0] #CATALOG_KEY_BYTES
    if pckey == 0xffff: return [0, -18, 0] #CTRL_CATALOG_KEY_BYTES
    if pckey == 0xffff: return [94, -109, 0] #POWER_KEY_BYTES
    if pckey == 0xffff: return [0, -21, 0] #CTRL_POWER_KEY_BYTES
    if pckey == 0xffff: return [0, 116, 0] #SIN_KEY_BYTES
    if pckey == 0xffff: return [0, -24, 0] #CTRL_SIN_KEY_BYTES
    if pckey == 0xffff: return [0, 84, 0] #COS_KEY_BYTES
    if pckey == 0xffff: return [0, -26, 0] #CTRL_COS_KEY_BYTES
    if pckey == 0xffff: return [0, 52, 0] #TAN_KEY_BYTES
    if pckey == 0xffff: return [0, -28, 0] #CTRL_TAN_KEY_BYTES
    if pckey == 0xffff: return [47, 20, 0] #SLASH_KEY_BYTES
    if pckey == 0xffff: return [0, -30, 0] #CTRL_SLASH_KEY_BYTES
    if pckey == 0xffff: return [0, -109, 0] #SQUARE_KEY_BYTES
    if pckey == 0xffff: return [0, -110, 0] #CTRL_SQUARE_KEY_BYTES
    if pckey == ord('7'): return [55, 113, 0] #SEVEN_KEY_BYTES
    if pckey == 0xffff: return [0, -41, 0] #CTRL_SEVEN_KEY_BYTES
    if pckey == ord('8'): return [56, 81, 0] #EIGHT_KEY_BYTES
    if pckey == 0xffff: return [0, -40, 0] #CTRL_EIGHT_KEY_BYTES    
    if pckey == ord('9'): return [57, 49, 0] #NINE_KEY_BYTES     
    if pckey == 0xffff: return [0, -39, 0] #CTRL_NINE_KEY_BYTES  
    if pckey == ord('*'): return [42, 19, 0] #TIMES_KEY_BYTES 
    if pckey == 0xffff: return [0, -31, 0] #CTRL_TIMES_KEY_BYTES
    if pckey == 0xffff: return [0, -20, 0] #TEN__POWER_KEY_BYTES 
    if pckey == 0xffff: return [0, -108, 0] #CTRL_TEN_POWE_KEY_BYTES
    if pckey == ord('4'): return [52, 114, 0] #FOUR_KEY_BYTES     
    if pckey == 0xffff: return [0, -44, 0] #CTRL_FOUR_KEY_BYTES     
    if pckey == ord('5'): return [53, 82, 0] #FIVE_KEY_BYTES     
    if pckey == 0xffff: return [0, -43, 0] #CTRL_FIVE_KEY_BYTES      
    if pckey == ord('6'): return [54, 50, 0] #SIX_KEY_BYTES     
    if pckey == 0xffff: return [0, -42, 0] #CTRL_SIX_KEY_BYTES      
    if pckey == ord('-'): return [45, 18, 0] #MINUS_KEY_BYTES      
    if pckey == 0xffff: return [0, -32, 0] #CTRL_MINUS_KEY_BYTES      
    if pckey == 0xffff: return [0, -54, 0] #E_POWER_KEY_BYTES     
    if pckey == 0xffff: return [0, -87, 0] #CTRL_E_POWER_KEY_BYTES      
    if pckey == ord('1'): return [49, 115, 0] #ONE_KEY_BYTES      
    if pckey == 0xffff: return [0, -47, 0] #CTRL_ONE_KEY_BYTES     
    if pckey == ord('2'): return [50, 83, 0] #TWO_KEY_BYTES      
    if pckey == 0xffff: return [0, -46, 0] #CTRL_TWO_KEY_BYTES      
    if pckey == ord('3'): return [51, 51, 0] #THREE_KEY_BYTES     
    if pckey == 0xffff: return [0, -45, 0] #CTRL_THREE_KEY_BYTES      
    if pckey == ord('+'): return [43, 17, 0] #PLUS_KEY_BYTES      
    if pckey == 0xffff: return [0, -33, 0] #CTRL_PLUS_KEY_BYTES     
    if pckey == 0xffff: return [0, 11, 0] #ON_KEY_BYTES    
    if pckey == 0xffff: return [0, -16, 0] #CTRL_ON_KEY_BYTES   
    if pckey == ord('0'): return [48, 80, 0] #ZERO_KEY_BYTES  
    if pckey == 0xffff: return [0, -48, 0] #CTRL_ZERO_KEY_BYTES
    if pckey == ord('.'): return [46, 112, 0] #POINT_KEY_BYTES
    if pckey == ord('-'): return [-79, 48, 0] #NEG_KEY_BYTES
    if pckey == 0xffff: return [0, -82, 0] #CTRL_NEG_KEY_BYTES
    if pckey == 0x0d: return [13, 16, 0] #ENTER_KEY_BYTES     
    if pckey == 0xffff: return [0, -90, 0] #CTRL_ENTER_KEY_BYTES
    return [0, 0, 0]


rect = c_char_p(" " * 24)  # struct Rectangle

# ----------- get a path to navnet.dll ------
# Win32: C:\Program Files\Common Files\TI Shared\CommLib\1\NavNet 
# Win64: C:\Program Files (x86)\Common Files\TI Shared\CommLib\1\NavNet
if os.environ.get("CommonProgramFiles(x86)"):      # Win64
 pt = os.environ.get("CommonProgramFiles(x86)") 
 nndll = pt + '\TI Shared\CommLib\\1\NavNet' + "\\navnet.dll"
else:                              # Win32
 pt = os.environ.get("CommonProgramFiles") 
 nndll = pt +'\TI Shared\CommLib\\1\NavNet' + "\\navnet.dll"

############# load NavNet.dll 
nn = cdll.LoadLibrary(nndll)    

#------------ init navnet
status = nn.TI_NN_Init("-c 0 -d 0")
print "TI_NN_Init:%d" %(status)

#------------- setup the callback for TI_NN_RegisterNotifyCallback
CBFUNC = CFUNCTYPE(c_int)

cb_func2 = CBFUNC(notify_cb)

status = nn.TI_NN_RegisterNotifyCallback(0, cb_func2)
while partner_connected == 0:
 time.sleep(1)
print "TI_NN_RegisterNotifyCallback %d:" % (status)

oh = nn.TI_NN_CreateOperationHandle()
print "TI_NN_CreateOperationHandle %x:" % (oh)
nn.TI_NN_NodeEnumInit(oh)
nn.TI_NN_NodeEnumNext(oh,byref(nh))
nn.TI_NN_NodeEnumDone(oh)
nn.TI_NN_DestroyOperationHandle(oh)
oh = NULL
print "remote node handle:", byref(nh)
nn.TI_NN_GetNodeHandle(ch,byref(dh))

#--------- setup to send key event
nn.TI_NN_DestroyOperationHandle(oh)
oh = nn.TI_NN_CreateOperationHandle()
status = nn.TI_NN_Connect(nh,0x4042,byref(ch))  # connect to send events
print "TI_NN_Connect service 0x4042:%d" %(status)

status = nn.TI_NN_Write(ch, byref(VIRTUAL_KEY_STROKE_EVENT_COMMAND), 4 ) # set calc to receive virtual key
print "TI_NN_Write:%d" %(status)

while status == 1:
 if msvcrt.kbhit():                        # allows Ctrl-C
  pckey = ord(msvcrt.getche())              #.decode('ASCII')
  #if pckey >=0x20 and pckey < 0x80: print chr(pckey),
  if pckey == 0x0d: print
  if pckey == 0x08: print " \b",
  if pckey == 27: break
  if pckey == 0 or pckey == 224: pckey += 256*ord(msvcrt.getch())  # special keys
  keybytescode = getkeycode(pckey)
  # 0x08 == keydown event => 0x208 is virtual key
  keyEvent = '\x00\x00\x00\x00' + '\x08' + '\x02' + uchr(keybytescode[0]) + '\x00' + uchr(keybytescode[1]) + \
  '\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00' + uchr(keybytescode[2]) + '\x00'
  status = nn.TI_NN_Write(ch, keyEvent, 26 )   # send key
  if status == 1: status = nn.TI_NN_Write(ch, byref(VIRTUAL_KEY_STROKE_EVENT_COMMAND), 4 ) # set for next key
 time.sleep(.125)
  
nn.TI_NN_DestroyOperationHandle(oh)
nn.TI_NN_Disconnect(ch)
nn.TI_NN_Shutdown()
